package com.meishe.sdkdemo.utils;

import android.app.Activity;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.provider.MediaStore;
import android.util.Log;
import android.view.View;
import android.widget.Button;

import com.meicam.sdk.NvsThumbnailView;
import com.meishe.sdkdemo.R;

/**
 * @author LiFei
 * @version 1.0
 * @title
 * @description 该类主要功能描述
 * @company
 * @created 2019/8/15 16:28
 * @changeRecord [修改记录] <br/>
 */
public class TestActivity extends Activity {
    private NvsThumbnailView mThumbnailView;
    private Button select_picture, select_video;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_test);
        mThumbnailView = findViewById(R.id.nvrb_view);
        select_video = findViewById(R.id.select_video);
        select_picture = findViewById(R.id.select_picture);

        select_picture.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(Intent.ACTION_PICK);
                intent.setDataAndType(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, "image/*");
                startActivityForResult(intent, 100);
            }
        });
        select_video.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent i = new Intent(Intent.ACTION_PICK, MediaStore.Video.Media.EXTERNAL_CONTENT_URI);
                startActivityForResult(i, 66);
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK && null != data) {
            if (requestCode == 66) {
                Uri selectedVideo = data.getData();
                String[] filePathColumn = {MediaStore.Video.Thumbnails._ID,MediaStore.Video.Media.DATA};
                Cursor cursor = getContentResolver().query(selectedVideo,
                        filePathColumn, null, null, null);
                cursor.moveToFirst();
                int videoId = cursor.getInt(cursor.getColumnIndex(filePathColumn[0]));
                int columnIndex = cursor.getColumnIndex(filePathColumn[1]);
                String videoPath;
                if(Build.VERSION.SDK_INT == Build.VERSION_CODES.P){
                    videoPath =MediaStore.Video.Media
                            .EXTERNAL_CONTENT_URI
                            .buildUpon()
                            .appendPath(String.valueOf(videoId)).build().toString();
                }else{
                    videoPath = cursor.getString(columnIndex);
                }
                Log.i("lifei", "--->video: " + videoPath);
                cursor.close();
                mThumbnailView.setMediaFilePath(videoPath);
                mThumbnailView.setTag(videoPath);
            } else if (requestCode == 100) {
                Uri selectedImage = data.getData();
                String[] filePathColumn = {MediaStore.Images.Media._ID,MediaStore.Images.Media.DATA};
                Cursor cursor = getContentResolver().query(selectedImage,
                        filePathColumn, null, null, null);
                cursor.moveToFirst();
                int id = cursor.getInt(cursor.getColumnIndex(filePathColumn[0]));
                int columnIndex = cursor.getColumnIndex(filePathColumn[1]);
                Log.i("lifei","---->id: "+id+"  columnIndex:"+columnIndex);
                String imagePath;
                if(Build.VERSION.SDK_INT == Build.VERSION_CODES.P){
                    imagePath =MediaStore.Images.Media.EXTERNAL_CONTENT_URI
                            .buildUpon()
                            .appendPath(String.valueOf(id)).build().toString();

                }else{
                    imagePath = cursor.getString(columnIndex);
                }
                cursor.close();
                Log.i("lifei","---> picture: "+imagePath);

                mThumbnailView.setMediaFilePath(imagePath);
               // mThumbnailView.setTag(imagePath);
            }
        }
    }

}
